#--------------------------------------------------------------------
#
#   PyGUI - DrawableContainer - Win32
#
#--------------------------------------------------------------------

from GUI.Canvases import Canvas
from GUI.GDrawableContainers import DrawableContainer as GDrawableContainer

class DrawableContainer(GDrawableContainer):

    def update(self):
        self._win.UpdateWindow()

    def with_canvas(self, body):
        win = self._win
        dc = win.GetDC()
        self._win_prepare_dc(dc)
        try:
            canvas = Canvas._from_win_dc(dc)
            body(canvas)
        finally:
            win.ReleaseDC(dc)

    def OnPaint(self):
        win = self._win
        dc, ps = win.BeginPaint()
        try:
            self._win_prepare_dc(dc)
            update_rect = ps[2]
            canvas = Canvas._from_win_dc(dc)
            self.draw(canvas, update_rect)
        finally:
            win.EndPaint(ps)

    def _win_prepare_dc(self, dc):
        pass
